%bcond_without  python2
%bcond_with     testpy

Name:           jpype
Version:        0.6.0
Release:        1
Summary:        Full access for Python programs to Java class libraries

# Some files come from JDK (jni_md.h) and Python (capsulethunk.h)
License:        ASL 2.0 and GPLv2 and Python
URL:            http://jpype.sf.net
Source0:        https://github.com/originell/%{name}/archive/v%{version}.tar.gz#/%{name}-%{version}.tar.gz

BuildRequires:  python3-devel python3-setuptools
BuildRequires:  java-devel
BuildRequires:  python-sphinx python-sphinx_rtd_theme
# need ant for tests execution
BuildRequires:  ant

%if %{with python2}
BuildRequires:  python-devel python-setuptools
%endif


%description
JPype is an effort to allow python programs full access to
java class libraries. This is achieved not through
re-implementing Python, as Jython/JPython has done, but rather
through interfacing at the native level in both Virtual Machines.


%package doc
Summary:         Documentation files for %{name}
BuildArch:       noarch

%description doc
%{summary}.


%prep
%setup -q
# sanify line delimiters
find . -name '*.py' -or -name '*.java' -or -name '*.TXT' \
 -or -name '*.sh' -or -name '*.xml' -or -name '*.js' \
 |xargs sed -i "s|\r||g"

%build
mkdir python3
pushd python3
cp -avp ../%{name}* .
#find . -name \*.py |xargs sed -i -e '1i#!%{__python3}'
%{__python3} ../setup.py build
popd
%if %{with python2}
mkdir python2
pushd python2
cp -avp ../%{name}* .
#find . -name \*.py |xargs sed -i -e '1i#!%{__python2}'
%{__python2} ../setup.py build
%endif
pushd ../doc
make %{?_smp_mflags} html
rm -rf _build/html/.buildinfo _build/html/_static

%install
pushd python3
%{__python3} ../setup.py install -O1 --skip-build --root %{buildroot}
# workaround for cpython bug
mv %{buildroot}%{python3_sitearch}/_%{name}.cpython*.so %{buildroot}%{python3_sitearch}/_%{name}.so
%if %{with python2}
pushd ../python2
%{__python2} ../setup.py install -O1 --skip-build --root %{buildroot}
popd
%endif
find %{buildroot} -name '*.so' |xargs chmod 0755


%check
pushd test
ant test
%if %{with testpy}
# fake a module installation
export PYTHONPATH=%{buildroot}%{python3_sitearch}
%{__python3} testsuite.py
%endif


%files
%license LICENSE
%doc *.rst doc/*.rst
%{python3_sitearch}/*
%if %{with python2}
%{python2_sitearch}/*
%endif

%files doc
%license LICENSE
%doc examples/
%doc test/
%doc doc/_build/html/


%changelog
* Tue Jun 23 2015 Raphael Groner <projects.rg@smart.ms> - 0.6.0-1
- based on originally jpype-py3.spec
- official jpype 0.6.0 with python3
- more documentation in subpackage

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0-0.3.20150202gitca6fc96
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Apr 23 2015 Raphael Groner <projects.rg@smart.ms> - 0-0.2.20150202gitca6fc96
- add GPLv2 for bundled source files
- remove wrong sitearch macro
- make tests work

* Thu Apr 02 2015 Raphael Groner <projects.rg@smart.ms> - 0-0.1.20150202gitca6fc96
- initial
